-- Addon Name  : MrBigglesworthDeath
-- Notes:      : Displays who killed Mr Bigglesworth, Kul'Thuzad's cat in Naxxramas to chat frame 1
-- and plays ominous thunder in case the player missed chat.
-- Date: 2020-01-19T16:51:58Z

-- localize the addon. we don't need to specify enUS as that is the default
local L = setmetatable({}, {__index = function(t, k)
	local v = tostring(k)
	rawset(t, k, v)
	return v
end})

if GetLocale() == "deDE" then
L["\"%s killed %s, May he Rest In Peace.\""] = "%s hat %s gekillt, Möge er In Frieden ruhen."

	return
end

if GetLocale() == "esES" or GetLocale() == "esMX" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

if GetLocale() == "frFR" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

if GetLocale() == "itIT" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

if GetLocale() == "koKR" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

if GetLocale() == "ptBR" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

if GetLocale() == "ruRU" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

if GetLocale() == "zhCN" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

if GetLocale() == "zhTW" then
--[[Translation missing --]]
--[[ L["\"%s killed %s, May he Rest In Peace.\""] = ""--]] 

	return
end

local spelldamage = {
	["SPELL_DAMAGE"] = true,
	["SPELL_PERIODIC_DAMAGE"] = true,
	["RANGE_DAMAGE"] = true,
}

local f = CreateFrame("Frame")

function f:OnEvent(event, ...)
	--@non-debug@
	if not IsInInstance() then return end -- we aren't in an instance
	local instanceID = select(8, GetInstanceInfo())
	if instanceID ~= 533 then return end -- the instance is not Naxxramas
	--@end-non-debug@

	local _, subevent, _, _, sourceName, _, _, destGUID, destName = ...
	local overkill
	if spelldamage[subevent] then
		overkill = select(16, ...)
	elseif subevent == "SWING_DAMAGE" then
		overkill = select(13, ...)
	elseif subevent == "ENVIRONMENTAL_DAMAGE" then
		overkill = select(14, ...)
	else
		return
	end

	if overkill > 0 then
		local npcID = select(6, strsplit("-", destGUID))
		if tonumber(npcID) == 16998 then
			SendChatMessage(format(L["%s killed %s, May he Rest In Peace."], sourceName, destName), IsInRaid() and "RAID" or IsInGroup() and "PARTY" or "SAY")
			PlaySoundFile("Interface/AddOns/MrBigglesworthDeath/Sounds/thunder.ogg", "Master")
			f:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end
	end
end

f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:SetScript("OnEvent", function(self, event)
	self:OnEvent(event, CombatLogGetCurrentEventInfo())
end)
